#
# Revision: 3.0.180532
#
# Copyright (c) 2018 Dell Technologies Inc.
# All rights reserved.
#
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
# DELL EMC CORPORATION. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
# WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF DELL EMC.
#
package sc::object;
use strict;
use warnings;
use parent 'ISerializable';





#@method
#@override
sub properties  { qw (name id type isValid) }

#@method
#@returns sc::api
sub api         { $_[0]->{sc::api::APISession()}        || 0  }


#@method
sub id          { $_[0]->{sc::api::ATTRInstanceId()}    || 0  }


#@method
sub name        { $_[0]->{sc::api::ATTRInstanceName()}  || '' }


#@method
sub type        { $_[0]->{sc::api::ATTRObjectType()}    || '' }


#@method
sub isValid     { $_[0]->{sc::api::APIValidObject()}    || 0  }


#@method
#@returns sc::response
sub GET         { my ($self, $url)          = @_; return $self->api->_submit('GET',     $url, $self->id, 0) }

#@method
#@returns sc::response
sub DELETE      { my ($self, $url, @body)   = @_; return $self->api->_submit('DELETE',  $url, $self->id, 0, @body) }

#@method
#@returns sc::response
sub DELETE_ASYNC{ my ($self, $url, @body)   = @_; return $self->api->_submit('DELETE',  $url, $self->id, 1, @body) }

#@method
#@returns sc::response
sub POST        { my ($self, $url, @body)   = @_; return $self->api->_submit('POST',    $url, $self->id, 0, @body) }

#@method
#@returns sc::response
sub POST_ASYNC  { my ($self, $url, @body)   = @_; return $self->api->_submit('POST',    $url, $self->id, 1, @body) }


1;