#
# Revision: 3.0.180532
#
# Copyright (c) 2018 Dell Technologies Inc.
# All rights reserved.
#
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
# DELL EMC CORPORATION. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
# WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF DELL EMC.
#
package sc::response;
use parent ISerializable;
use strict;
use warnings;



#@method
#@override
sub properties  { qw (success info data request) }


#@method
#@returns sc::api
sub api         { $_[0]->{sc::api::APISession()} }


#@method
sub success     { $_[0]->{sc::api::APIResponseSuccess()}    || 0  }


#@method
sub info        { $_[0]->{sc::api::APIResponseInfo()}       || '' }


#@method
sub request     { $_[0]->{sc::api::APIResponseRequest()}    || '' }


#@method
sub data        { $_[0]->{sc::api::APIResponseDataRaw()}    || '' }


#@method
sub asArray     { return ($_[0]->{sc::api::APIResponseData()} || []) unless wantarray; @{ $_[0]->{sc::api::APIResponseData()} || [] } }


#@method
sub asHash      { $_[0]->asArray->[0] || {} }

#@method
#@returns sc::object
sub asObject    { my $self = shift; my $class = shift || '';
                  return $self->api->wrap($self->asHash, $class) unless wantarray;
                  return map { $self->api->wrap($_, $class) } grep { $_ } $self->asArray; }



1;