#
# Revision: 3.0.180532
#
# Copyright (c) 2018 Dell Technologies Inc.
# All rights reserved.
#
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
# DELL EMC CORPORATION. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
# WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF DELL EMC.
#
package sc::server;
use strict;
use warnings;
use parent 'sc::object';


#@method
sub volumes       { my $self = shift; return map { $self->api->inflate($_->{sc::api::ATTRVolume()}, 'sc::volume') } $self->GET(sc::api::URLVolMappingProfiles())->asArray; }


#@method
#@returns sc::server
sub cluster       { my $self = shift;
                    if (sc::api::TYPE_ServerCluster() eq ($self->{sc::api::ATTRParent()}->{sc::api::ATTRObjectType()}||'')) {
                        my      $cluster = $self->api->inflate($self->{sc::api::ATTRParent()}, 'sc::server');
                        return  $cluster if $cluster->isValid;
                    }
                    return $self
                  }

#@method
sub ssn           { $_[0]->{sc::api::ATTRScSSN()} || '' };



1;