#
# Revision: 3.0.180532
#
# Copyright (c) 2018 Dell Technologies Inc.
# All rights reserved.
#
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
# DELL EMC CORPORATION. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
# WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF DELL EMC.
#
package sc::storagecenter;
use strict;
use warnings;
use parent 'sc::object';


#@method
sub status      { $_[0]->{sc::api::ATTRStatus} || '' }


#@method
sub isUp        { $_[0]->isValid && ($_[0]->status eq sc::api::STATE_UP()) }


#@method
#@returns sc::remotesc
sub remoteNodes   { $_[0]->GET(sc::api::URLRemoteSCList())->asObject('sc::remotesc') };

#@method
#@returns sc::volume
sub newVolume     { my ($self, $name, $size) = @_;
                    return $self->POST(sc::api::URLVolumes(),
                                            sc::api::PARAM_VOL_StorageCenter() => $self->id,
                                            sc::api::PARAM_VOL_Name() => $name,
                                            sc::api::PARAM_VOL_Size() => $size)->asObject('sc::volume');
                  };



1;