#
# Revision: 3.0.180532
#
# Copyright (c) 2018 Dell Technologies Inc.
# All rights reserved.
#
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
# DELL EMC CORPORATION. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
# WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF DELL EMC.
#
package ISerializable;
use strict;
use warnings;
use SCTools qw(DUMP);





#@method
sub properties { return () }



#@method
sub toString() {

    my ($self, @properties) = @_;
    @properties = $self->properties() unless @properties;
    return join('; ', (map { "$_=" . ($self->$_ || 0) } grep { $_ && $self->can($_) } @properties))
}



#@method
sub toHash() {

    my ($self, @properties) = @_;
    @properties = $self->properties() unless @properties;
    return map { $_ => ($self->can($_) ? ($self->$_ || 0) : '(not implemented)') } grep { $_ } @properties
}



1;