#!/bin/sh
#
# Revision: 3.0.180532
#
# Copyright (c) 2018 Dell Technologies Inc.
# All rights reserved.
#
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
# DELL EMC CORPORATION. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
# WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF DELL EMC.
#

ro=`haclus -value ReadOnly`
if [ "$ro" -eq 1 ]; then haconf -makerw; fi

hatype -add SC
hatype -modify  SC SourceFile              "SCTypes.cf"
hatype -modify  SC ActionTimeout            300 
hatype -modify  SC SupportedActions         configure takeover rescan rename_media halog_on halog_off
hatype -modify  SC InfoInterval             900
hatype -modify  SC InfoTimeout              120
hatype -modify  SC MonitorInterval          300
hatype -modify  SC MonitorTimeout           300
hatype -modify  SC CleanTimeout             300
hatype -modify  SC CleanRetryLimit          1
hatype -modify  SC LogDbg                   DBG_1 DBG_2 DBG_3 DBG_4 DBG_AGINFO
hatype -modify  SC OfflineMonitorInterval   900
hatype -modify  SC OnlineTimeout            900
hatype -modify  SC OnlineRetryLimit         1
hatype -modify  SC ArgList                  State IState DSMPrimary DSMStandby DSMPort UserName Password Volumes Servers LogFile AutoTakeover
hatype -modify  SC AEPTimeout               1
hatype -modify  SC LogViaHalog              1
hatype -modify  SC FaultOnMonitorTimeouts   0
hatype -modify  SC FireDrill                0
haattr -default SC Critical                 0
haattr -add     SC DSMPrimary   -string  -scalar "0.0.0.0"
haattr -add     SC DSMStandby   -string  -scalar ""
haattr -add     SC DSMPort      -integer -scalar "3033"
haattr -add     SC UserName     -string  -scalar "Admin"
haattr -add     SC Password     -string  -scalar "Admin"
haattr -add     SC LogFile      -string  -scalar "/tmp/sc.agent"
haattr -add     SC Volumes      -string  -assoc
haattr -add     SC Servers      -string  -assoc
haattr -add     SC AutoTakeover -integer -scalar "0"

if [ $ro -eq 1 ]; then haconf -dump -makero; else haconf -dump; fi