#
# Revision: 3.0.180532
#
# Copyright (c) 2018 Dell Technologies Inc.
# All rights reserved.
#
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
# DELL EMC CORPORATION. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
# WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF DELL EMC.
#
package sc::connection;
use strict;
use warnings;
use parent 'sc::object';


#@override
sub properties { qw (name version host port user provider isConnected isValid) }
sub isConnected { $_[0]->{sc::api::ATTRPConnected()}        || 0 };
sub version     { $_[0]->{sc::api::ATTRApiVersion()}        || 0 };
sub host        { $_[0]->{sc::api::ATTRHostName()}          || ''};
sub port        { $_[0]->{sc::api::ATTRWebPort()}           || 0 };
sub user        { $_[0]->{sc::api::ATTRUserName()}          || ''};
sub provider    {($_[0]->{sc::api::ATTRProvider()}||'') . ' (' . ($_[0]->{sc::api::ATTRProviderVersion()}||'') . ')' };

1;



#apiBuild           : 0
#apiVersion         : 3.3
#application        : 0
#applicationVersion : 0
#commandLine        : 0
#connected          : true
#connectionKey      : 0
#hostName           : 192.168.100.228
#instanceId         : 0
#instanceName       : ApiConnection
#locale             : en_US
#minApiVersion      : 0.1
#objectType         : ApiConnection
#provider           : EnterpriseManager
#providerVersion    : 16.3.1.301
#secureString       : 0
#sessionKey         : 1507792850610
#source             : REST
#useHttps           : 0
#userId             : 434226
#userName           : Admin
#webServicesPort    : 3033