#
# Revision: 3.0.180532
#
# Copyright (c) 2018 Dell Technologies Inc.
# All rights reserved.
#
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
# DELL EMC CORPORATION. USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
# WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF DELL EMC.
#
package sc::hba;
use strict;
use warnings;
use parent 'sc::object';





#@method
#@override
sub properties  { qw (name ssn serverName isRemoteSC) }


#@method
sub ssn         { $_[0]->{sc::api::ATTRScSSN()} || '' };


#@method
sub wwns        { @{ $_[0]->{sc::api::ATTRPortWWNs()} || [] } };


#@method
sub isRemoteSC  { $_[0]->{sc::api::ATTRRemoteStorageCenter()} }


#@method
sub serverID    { $_[0]->{sc::api::ATTRServer()}->{sc::api::ATTRInstanceId()} || 0 }


#@method
sub serverName  { $_[0]->{sc::api::ATTRServer()}->{sc::api::ATTRInstanceName()} || '' }


#@method
#@returns sc::server
sub server      { $_[0]->serverID ? $_[0]->api->inflate($_[0]->{sc::api::ATTRServer()}, 'sc::server') : $_[0]->api->dummy_object(sc::api::TYPE_Server()) }



1;